
/*
 * Simple Bitmap drawing lib
 */

/*  2001 Serge Rosmorduc
 * rosmord@iut.univ-paris8.fr
 *
 * Tout droits rservs.
 * 
 * voyez le fichier ../LICENCE.txt pour plus d'informations
 * See the ../LICENCEE.txt file for more information
 *
 * $Id: SimpleBitmap.h,v 1.1.1.1 2002/04/16 13:55:00 rosmord Exp $
 *
 */

/*
 * $Log: SimpleBitmap.h,v $
 * Revision 1.1.1.1  2002/04/16 13:55:00  rosmord
 * Imported using tkCVS
 *
 */

/**
 *
 * Note on the coordinate system :
 * In this plain bitmap library,
 * the (0,0) origin point is the upper-left one.
 * the y axis is oriented toward the bottom.
 */

#ifndef SIMPLEBITMAP_H
#define SIMPLEBITMAP_H

#include <stdio.h>

typedef struct SimpleBitmapS {
  int w;
  int h;
  int wchar;
  int memsize;
  unsigned char *d;
} SimpleBitmap;

SimpleBitmap *
SimpleBitmap_init(int w, int h);

void
SimpleBitmap_free(SimpleBitmap *o);

void
SimpleBitmap_iplot(SimpleBitmap *o, int x, int y, int BLACK);

void
SimpleBitmap_iline(SimpleBitmap *o,
		   int x1,  int y1,
		   int x2,  int y2,
		   int black);

void
SimpleBitmap_fillPolygon(
			 SimpleBitmap *o,
			 int npoints, 
			 XPoint * lespoints,
			 int isBlack);


void
SimpleBitmap_clean(SimpleBitmap *o);

void
SimpleBitmap_toPBMFile(FILE * f, SimpleBitmap *o);

#endif

/*
 * Local Variables:
 * tab-width: 2
 * End:
 */
