/*
 * Window clipboard drawing
 */

/*  2000 Serge Rosmorduc,
 * quipe EC.art, Laboratoire LRIA, Universit de Paris 8
 *
 * 15 rue Catulienne
 * 93236 St Denis Cedex
 * FRANCE
 *
 * Tout droits rservs.
 * 
 * voyez le fichier ../LICENCE.txt pour plus d'informations
 * See the ../LICENCEE.txt file for more information
 *
 * $Id: TKSO_WCB.h,v 1.1.1.1 2002/04/16 13:55:00 rosmord Exp $
 *
 */

/*
 * $Log: TKSO_WCB.h,v $
 * Revision 1.1.1.1  2002/04/16 13:55:00  rosmord
 * Imported using tkCVS
 *
 */

#ifndef TKSO_WCB_H
#define TKSO_WCB_H

#include "tgraph.h"
#include <windows.h>
#include <wingdi.h>

typedef struct TKSO_WCB_S {
	TKSESH_output header;
	int enmh;											/* true if we want an enhanced Meta File */
	HDC dc; /* device context for drawing */
	HDC olddc;
	HDC deviceDC;
	int mappingMode;
	HPEN blackPen, redPen, whitePen, wideBlackPen, wideRedPen, nullPen;
	HBRUSH blackBrush, redBrush, whiteBrush;
	int mmW, mmH; /* W and H for the plain metafiles headers */
} TKSO_WCB;

typedef struct {
	int x, y;
} WCBpoint;
/* 
 * tkso_wmf_init --
 *      lineHeight: height of a hieroglyphic line in mm.
 * Creates a new output corresponding to a tk window 
*/

TKSO_WCB *
TKSO_WCB_init(double x1, double y1,
							double x2, double y2, double lineHeight, int ENHANCED);

/*
 * returns : TRUE if success. FALSE if failure. Failure might indicate some problem with
 * clipboard opening 
 */

int
TKSO_WCB_free(TKSO_WCB *o);

#endif

/* Let's preserve the present presentation
 * Local Variables:
 * tab-width: 2
 * c-block-comments-indent-p: nil
 * End:
 */
