/*
 * Heading for the bitmap drawing device for tksesh
 * This device allows one to draw on bitmap.
 * The bitmap can then converted either to a xbm or a pbm file
 */

/*  2000 Serge Rosmorduc,
 * quipe EC.art, Laboratoire LRIA, Universit de Paris 8
 *
 * 15 rue Catulienne
 * 93236 St Denis Cedex
 * FRANCE
 *
 * Tout droits rservs.
 * 
 * voyez le fichier ../LICENCE.txt pour plus d'informations
 * See the ../LICENCEE.txt file for more information
 *
 * $Id: TKSO_bitmap.h,v 1.1.1.1 2002/04/16 13:55:00 rosmord Exp $
 *
 */

/*
 * $Log: TKSO_bitmap.h,v $
 * Revision 1.1.1.1  2002/04/16 13:55:00  rosmord
 * Imported using tkCVS
 *
 *
 */

#ifndef TKSO_bitmap_H
#define TKSO_bitmap_H

#include "SimpleBitmap.h"
#include "tgraph.h"
#include "tcl.h"

typedef struct TKSO_BITMAP_S {
	TKSESH_output header;
	SimpleBitmap * bitmap;
} TKSO_bitmap;

/* 
 * tkso_bitmap_init --
 * Creates a new output.
 */

TKSO_bitmap *
TKSO_bitmap_init(double x1, double y1,
								 double x2, double y2, 
								 int w, int h);
/*
 * TKSO_bitmap_free --
 * frees the resources allocated for a bitmap.
 */

void
TKSO_bitmap_free(TKSO_bitmap *o);


Tcl_Obj *
TKSO_bitmap_getPBM(TKSO_bitmap *o);

Tcl_Obj *
TKSO_bitmap_getXBM(TKSO_bitmap *o);

#endif

/* Let's preserve the present presentation
 * Local Variables:
 * tab-width: 2
 * c-block-comments-indent-p: nil
 * End:
 */
