#ifndef MDC_COORDS_H
#define MDC_COORDS_H


#include <strings.h>
#include <stdlib.h>
/* #include <ctype.h>*/

#include <tcl.h>								/* because of interp, needed for regexps... */
																/* It would be better for modularity 
																	 to use another library, but costlier... */

#include "general.h"
#include "mdctexte.h"

/* the way textual coordinates are handled */
/* remark the 0 coordinate could be used for quadra numbering */
/* it is NOT */

typedef struct {
	enum type_coordinate { numeric_coordinates, symbolic_coordinates} type;
	unsigned int max_val;
	char ** coords;
} Textual_Coordinate_Description;

typedef struct _Coordinate_System{
	Tcl_Interp *interp;						/* needed for regexp ?  */
	char *show_coordinates;				/* printf-style array */
	char *read_coordinates;				/* array for reading the coordinates */
	int  coordinates_order[10];		/* order for the coordinates */
	Textual_Coordinate_Description coordinates_description[10];
} Coordinate_System;

/*****************************************************************************
	coordonnes textuelles.
	
	****************************************************************************/

void
set_type_coordinate(Coordinate_System * sys, int number, int argc, char **argv);

void
set_format_coordinate(Coordinate_System *sys, char *descr);

void
set_text_coordinate(Coordinate_System *sys, char* descr, coordsvect coords);

char *
get_text_coordinates(Coordinate_System *sys, coordsvect coords);

void
init_text_coordinates(Coordinate_System *sys, Tcl_Interp *interp);

#endif /*ifndef MDC_COORDS_H*/

/* Let's preserve the present presentation
 * Local Variables:
 * tab-width: 2
 * c-block-comments-indent-p: nil
 * End:
 */
