#ifndef TKSAFF_H
#define TKSAFF_H

#include "mdctexte.h"
#include "tksesh.h"

/* Ration from line height to column width. */
#define COLUMNRATIO 1.2

/**
 * TKSESH_isCadratHorizontallyVisible --
 * 		Sends back TRUE if the horizontal position of the cadrat is such that the cadrat should 
 *    be visible.
 * 
 *    If it isn't, *pos will contain a proposition for a left window start coordinate which
 *    would make the cadrat visible.
 */

int 
TKSESH_isCadratHorizontallyVisible(Sesh * hiero, GeneralIndex cadrat, double *x);

int 
TKSESH_isCadratVerticallyVisible(Sesh * hiero, GeneralIndex cadrat, GeneralIndex *debut);

/*
 * TKSESH_redrawWidget --
 * 	redraws the widget.
 *
 * 	hiero : where to draw
 */

void
TKSESH_redrawWidget(Sesh *hiero);


#endif /* TKSAFF_H */

/*
 * Local Variables:
 * tab-width: 2
 * End:
 */
