/*
 * Portable library for writing Windows Metafiles
 * At the time being, limited to stuff needed for tksesh
 *
 */
/*  2000 Serge Rosmorduc,
 * quipe EC.art, Laboratoire LRIA, Universit de Paris 8
 *
 * 15 rue Catulienne
 * 93236 St Denis Cedex
 * FRANCE
 *
 * Tout droits rservs.
 * 
 * voyez le fichier ../LICENCE.txt pour plus d'informations
 * See the ../LICENCEE.txt file for more information
 *
 * $Id: wmf.h,v 1.1.1.1 2002/04/16 13:55:00 rosmord Exp $
 *
 */

/*
 * $Log: wmf.h,v $
 * Revision 1.1.1.1  2002/04/16 13:55:00  rosmord
 * Imported using tkCVS
 *
 * Revision 1.1  2000/08/04 11:49:51  rosmord
 * Initial revision
 *
 */

#ifndef WMF_H
#define WMF_H

typedef short int WMFSHORT;
typedef short WMFWORD;
typedef unsigned short UWMFWORD;
typedef int WMFDWORD;

/* Map modes */
#define MM_TEXT		  1
#define MM_LOMETRIC	  2
#define MM_HIMETRIC	  3
#define MM_LOENGLISH	  4
#define MM_HIENGLISH	  5
#define MM_TWIPS	  6
#define MM_ISOTROPIC	  7
#define MM_ANISOTROPIC	  8

  /* Background modes */
#ifdef TRANSPARENT  /*Apparently some broken svr4 includes define TRANSPARENT*/
#undef TRANSPARENT
#endif
#define TRANSPARENT       1
#define OPAQUE            2
#define BKMODE_LAST       2

/* Raster operations */
/* for WMFSetROP2 */
#define R2_BLACK         1
#define R2_NOTMERGEPEN   2
#define R2_MASKNOTPEN    3
#define R2_NOTCOPYPEN    4
#define R2_MASKPENNOT    5
#define R2_NOT           6
#define R2_XORPEN        7
#define R2_NOTMASKPEN    8
#define R2_MASKPEN       9
#define R2_NOTXORPEN    10
#define R2_NOP          11
#define R2_MERGENOTPEN  12
#define R2_COPYPEN      13
#define R2_MERGEPENNOT  14
#define R2_MERGEPEN     15
#define R2_WHITE        16

/*
 * Pen Styles
 */
#define PS_SOLID         0x00000000
#define PS_DASH          0x00000001
#define PS_DOT           0x00000002
#define PS_DASHDOT       0x00000003
#define PS_DASHDOTDOT    0x00000004
#define PS_NULL          0x00000005
#define PS_INSIDEFRAME   0x00000006
#define PS_USERSTYLE     0x00000007
#define PS_ALTERNATE     0x00000008
#define PS_STYLE_MASK    0x0000000f

#define PS_ENDCAP_ROUND  0x00000000
#define PS_ENDCAP_SQUARE 0x00000100
#define PS_ENDCAP_FLAT   0x00000200
#define PS_ENDCAP_MASK   0x00000f00

#define PS_JOIN_ROUND    0x00000000
#define PS_JOIN_BEVEL    0x00001000
#define PS_JOIN_MITER    0x00002000
#define PS_JOIN_MASK     0x0000f000

#define PS_COSMETIC      0x00000000
#define PS_GEOMETRIC     0x00010000
#define PS_TYPE_MASK     0x000f0000

  /* Brush styles */
#define BS_SOLID	    0
#define BS_NULL		    1
#define BS_HOLLOW	    1
#define BS_HATCHED	    2
#define BS_PATTERN	    3
#define BS_INDEXED	    4
#define	BS_DIBPATTERN	    5
#define	BS_DIBPATTERNPT	    6
#define BS_PATTERN8X8	    7
#define	BS_DIBPATTERN8X8    8
#define BS_MONOPATTERN      9

  /* Hatch styles */
#define HS_HORIZONTAL       0
#define HS_VERTICAL         1
#define HS_FDIAGONAL        2
#define HS_BDIAGONAL        3
#define HS_CROSS            4
#define HS_DIAGCROSS        5

/* Stolen from wingdi */
#define RGB(r,g,b)          ((unsigned int)((r) | ((g) << 8) | ((b) << 16)))
// #define RGB(r,g,b)          ((unsigned int)((b) | ((g) << 8) | ((r) << 16)))

  /* Polygon modes */
#define ALTERNATE         1
#define WINDING           2
#define POLYFILL_LAST     2


typedef struct {
  WMFWORD x, y;
} WMFpoint;

typedef struct WMF * WMFPOINTER;

/*
 * Drawing functions
 */

void
WMFPolygon(struct WMF *w, WMFpoint *p, WMFWORD nbr);

void
WMFPolyLine(struct WMF *w, WMFpoint *p, WMFWORD nbr);

void
WMFArc(struct WMF *w, WMFWORD left, WMFWORD top, WMFWORD right, WMFWORD bottom, 
       WMFWORD xstart, WMFWORD ystart, WMFWORD xend, WMFWORD yend);

void
WMFMoveTo(struct WMF * w, WMFWORD x, WMFWORD y);

void
WMFLineTo(struct WMF *w, int x, int y);

void
WMFEllipse(struct WMF *w, WMFWORD left, WMFWORD top, WMFWORD right, WMFWORD bottom);

void
WMFRectangle(struct WMF *w, WMFWORD left, WMFWORD top, WMFWORD right, WMFWORD bottom);


void
WMFFloodFill(struct WMF * w, WMFWORD x, WMFWORD y, WMFDWORD colour);

void
WMFFillRgn(struct WMF * w, WMFWORD nbrush, WMFWORD nregion);

void
WMFInvertRgn(struct WMF * w, WMFWORD nregion);

void
WMFPaintRgn(struct WMF * w, WMFWORD nregion);

void
WMFSelectClipRgn(struct WMF * w, WMFWORD nregion);

void
WMFSetPixel(struct WMF * w, WMFWORD x, WMFWORD y, WMFDWORD colour);

void
WMFPatBlt(struct WMF *w, WMFWORD left, WMFWORD top, WMFWORD right, WMFWORD bottom, WMFDWORD rop);

void
WMFTextOut(struct WMF *w, WMFWORD x, WMFWORD y, char * s);
/*
 * window organization function
 */

void
WMFSetWindowOrg(struct WMF *w, WMFWORD x, WMFWORD y);

void
WMFSetWindowExt(struct WMF *w, WMFWORD x, WMFWORD y);

void
WMFSetViewportOrg(struct WMF *w, WMFWORD x, WMFWORD y);

void
WMFOffsetWindowOrg(struct WMF *w, WMFWORD x, WMFWORD y);

void
WMFOffsetViewportOrg(struct WMF *w, WMFWORD x, WMFWORD y);

void
WMFScaleWindowExt(struct WMF *w,WMFWORD xnum,WMFWORD xdenom,WMFWORD ynum,WMFWORD ydenom);

void
WMFScaleViewportExt(struct WMF *w,WMFWORD xnum,WMFWORD xdenom,WMFWORD ynum,WMFWORD ydenom);

void
WMFSetViewportExt(struct WMF *w, WMFWORD x, WMFWORD y);

/*
 * graphic context tuning
 */

void
WMFSetMapMode(struct WMF *w, WMFWORD map);

void
WMFSetBKMode(struct WMF *w, WMFWORD mode);

void
WMFSetBKColor(struct WMF *w, WMFDWORD color);

void
WMFSetTextColor(struct WMF *w, WMFDWORD color);

void
WMFSetROP2(struct WMF *w, WMFDWORD rop);

void
WMFSelectObject(struct WMF *w, UWMFWORD nobj);

void
WMFDeleteObject(struct WMF *w, UWMFWORD nobj);

void
WMFSaveDC(struct WMF *w);

void
WMFRestoreDC(struct WMF *w, UWMFWORD lev);

void
WMFSetPolyFillMode(struct WMF *w, int fillmode);

/* Return a value usable by WMFSelectObject */

UWMFWORD
WMFCreatePenIndirect(struct WMF *w, UWMFWORD style, UWMFWORD width, WMFDWORD colour);

/*
  style: BS_SOLID,BS_NULL & BS_HATCHED
  hatch : HS_HORIZONTAL, HS_VERTICAL, HS_FDIAGONAL, HS_BDIAGONAL, HS_CROSS, HS_DIAGCROSS.
*/

int
WMFCreateBrushIndirect(struct WMF *w, WMFWORD hatch, WMFDWORD colour, WMFWORD style);


/* Clipping */

void
WMFExcludeClipRect(struct WMF *w, WMFWORD left, WMFWORD top, WMFWORD right, WMFWORD bottom);

void
WMFIntersectClipRetc(struct WMF *w, WMFWORD left, WMFWORD top, WMFWORD right, WMFWORD bottom);

/*
 * Use the functions below to create and delete a
 * WMF object. You NEED to delete it, as deletion
 * will do some bookkeeping job.
 *
 * w and h are the size of the picture in 1/1440 inches (a.k.a TWIPS)
 * RELOC is a boolean flag. If TRUE, the created file will be a 
 * plain WMF file
 * placeable metafile
 * clipboard metafile
 * 
 * 
*/


struct WMF *
WMFinit(FILE *f, int w, int h, int  RELOC);

void
WMFFinish(struct WMF *w);

#endif
