
#define _POSIX_SOURCE 1


/*
	 Reading pbm files to xbm 
*/
#include <tk.h>
#include <stdio.h>
#include "fordll.h"


EXTERN EXPORT(int,Pbmtoxbm_Init) _ANSI_ARGS_((Tcl_Interp *interp));


static void 
lireligne(char *tmp, int i, FILE *f)
{
	tmp[0]= '#';
	while (tmp[0]== '#') {
		tmp[0]= fgetc(f);
		if (tmp[0]== '#') 
		{
			int c;
			do {
			c= fgetc(f);
			} while (c != EOF && c != '\n');
		}	
	}
	fgets(tmp+1, i -1, f);
}
 
int
SESH_pbm_to_xbm(ClientData clientData,
								Tcl_Interp *interp,
								int argc,
								char **argv)
{
	FILE *f;
	if (argc != 2)
		return TCL_ERROR;

	if ((f= fopen(argv[1], "rb")))
		{
			static char tmp[100];
			int dx, dy, x;
			int c;
			int num= 0;
			lireligne(tmp, 29, f);
			if (tmp[0] != 'P' || tmp[1] != '4')
				{
					Tcl_AppendResult(interp, "bad file ", argv[1], (char *) NULL);
					fclose(f);
					return TCL_ERROR;
				}
			do {
				lireligne(tmp, 29, f);
				/* printf("%c", tmp[0]);*/
			} while (tmp[0] == '#');
			sscanf(tmp,"%d %d", &dx, &dy);
			sprintf(tmp, "#define A_width %d\n#define A_height %d\n", dx, dy);
			Tcl_AppendResult(interp, tmp, (char *) NULL);
			Tcl_AppendResult(interp, "static char A_bits[] = {\n", (char *) NULL);
			x= 0;
			while ((c= getc(f)) != EOF)
				{
					x+= 8;
					sprintf(tmp, "0x%02x", 
									((c&1)<<7) + 
									((c&2)<<5)+ 
									((c&4)<<3)+ ((c&8)<<1)+ 
									((c&16)>>1)+ ((c&32)>>3)+ ((c&64)>>5)+ ((c&128)>>7));
					if (num != 0)
						{
							Tcl_AppendResult(interp, ",", (char *) NULL);
						}
					else
						num++;
					if (x >= dx)
						{
							Tcl_AppendResult(interp, "\n", (char *) NULL);
							x= 0;
						}
					Tcl_AppendResult(interp, tmp, (char *) NULL);
				}
			Tcl_AppendResult(interp, "};\n", (char *) NULL);
			fclose(f);
			return TCL_OK;
		}
	else
		{
			Tcl_AppendResult(interp, "can't find file ", argv[1], (char *) NULL);
			return TCL_ERROR;
		}
}

EXPORT(int,Pbmtoxbm_Init)(interp)
     Tcl_Interp *interp;
{
	Tcl_CreateCommand(interp, "pbm2xbm", SESH_pbm_to_xbm,
										(ClientData) interp, (Tcl_CmdDeleteProc *) NULL);
	return Tcl_PkgProvide(interp, "Pbmtoxbm", "1.0");
	return TCL_OK;
	
}

/*
 * Local Variables:
 * tab-width: 2
 * End:
 */
