
#include <stdlib.h>
#include "tcl.h"
#include "general.h"
#include "XPoint.h"
#include "SimpleBitmapTcl.h"
#include "chaine.h"

/**
 * SimpleBitmap_toPBM --
 *	 returns a TCL_object (a string)
 *
 * VERY IMPORTANT TCL NOTE :
 * Use ByteArrayObject and NOT StringObject for
 * binary values !!!!!!
 */

Tcl_Obj *
SimpleBitmap_toPBM(SimpleBitmap *o)
{
  Tcl_Obj *result;
  Tcl_Obj *tab;
  char s[100];

  result= Tcl_NewByteArrayObj(0,0);
  
  sprintf(s, "%d %d\n", o->w, o->h);

  Tcl_AppendStringsToObj(result,
			 "P4\n", 
			 "#Creator Tksesh Package\n", s, NULL);

  tab= Tcl_NewByteArrayObj(o->d, o->memsize);
  Tcl_AppendObjToObj(result, tab);
  return result;
}


/**
 * For XBM files, the bits should be reversed.
 */

Tcl_Obj *
SimpleBitmap_toXBM(SimpleBitmap *o, char * nom)
{
  Tcl_Obj *result;
  char width[100], height[100];
  char s[10];
  int col=0;			/* column in the resulting *text* (for nice presentation) */
  int i;

  result= Tcl_NewStringObj(0,0);
  
  sprintf(width, "%d", o->w);
  sprintf(height, "%d", o->h);

  Tcl_AppendStringsToObj(result,
			 "#define ", nom, "_width ", width, "\n",
			 "#define ", nom, "_height ", height, "\n",
			 "static char ", nom, "_bits[] = {", NULL);


  for (i= 0; i < o->memsize; i++)
    {
      int c0= o->d[i];
      int c;
      /* First, reverse c0 */
      c=  ((1 & c0) << 7)
	+ ((2 & c0) << 5) 
	+ ((4 & c0) << 3) 
	+ ((8 & c0) << 1)
	+ ((16 & c0) >> 1)
	+ ((32 & c0)  >> 3)
	+ ((64 & c0) >> 5)
	+ ((128 & c0) >> 7);

      if (i != 0)
	Tcl_AppendStringsToObj(result,", ", NULL);
      if (col++ % 10 == 0)
	Tcl_AppendStringsToObj(result,"\n", NULL);
      sprintf(s, "0x%02x", c);
      Tcl_AppendStringsToObj(result, s, NULL);
    }
  Tcl_AppendStringsToObj(result, "}\n", NULL);

  return result;
}
