#!/usr/local/TCL83/bin/tclsh8.3 
# Temporary version.

lappend auto_path /home/rosmord/tksesh/tcllib

package require Sbzr
package provide BzrToType1 1.0

namespace eval BzrToType1 {
    #	list : list describing the bzr font
    #	name : the name of the ps type 1 font to produce
    variable VAR
    namespace export bzrToType1

    set VAR(scale) [expr 1000/17.0]
    set VAR(hexa) 1
    
    proc map {f l} {
	set res [list]
	foreach i $l {
	    lappend res [$f $i]
	}
	return $res
    }

    proc convCoord {x} {
	variable VAR
	return [format "%.0f"  [expr $VAR(scale) * $x]]
    }

    proc bzrToAFM {list name} {
set head {StartFontMetrics 2.0
Comment generated by tksesh 
Comment DATE
FontName FONTNAME
FullName FONTFULLNAME
FamilyName FAMILY
Weight WEIGHT
Notice (made by FontEdit for tksesh)
ItalicAngle -13
IsFixedPitch false
UnderlinePosition -100
UnderlineThickness 50
Version VERSION
EncodingScheme FontSpecific
FontBBox BBOX
}
    set bbox [map convCoord [lindex $list 2]]
    set text [string map [list \
	    FONTNAME $name\
	    FONTFULLNAME $name\
	    FAMILY $name\
	    VERSION 1.0\
	    WEIGHT medium\
	    DATE [clock format [clock seconds]]\
	    BBOX $bbox\
	    ] $head]
    append text "StartCharMetrics [expr [llength $list] - 2]\n"
    append text "C 0 ; WX [expr [lindex $bbox 2] - [lindex $bbox 0]] ; N .notdef ; B $bbox\n"
    foreach c [lrange $list 3 end] {
	set code [lindex $c 0]
	puts "heading : [lrange $c 0 5]"
	set c [map convCoord [lrange $c 1 5]]
	set width [lindex $c 0]
	set llx [lindex $c 1]
	set lly [lindex $c 2]
	set urx [lindex $c 3]
	set ury [lindex $c 4]
	puts "llx= $llx; lly=$lly urx=$urx ury=$ury"
	append text "C $code ; WX $width ; N $name$code ; B $llx $lly $urx $ury\n"
    }
    append text "EndCharMetrics\n"
    append text "EndFontMetrics\n"    
    return $text
}

    proc bzrToType1 {list name} {
	set Header {%!FontType1-1.0: FONTNAME VERSION
%%CreationDate: DATE
11 dict begin
/FontInfo 10 dict dup begin
/version (001.001) readonly def
/Notice (NOTICE) readonly def
/FullName (FONTFULLNAME) readonly def
/FamilyName (FAMILY) readonly def
/Weight (WEIGHT) readonly def
/ItalicAngle -13 def
/isFixedPitch false def
/UnderlinePosition -100 def
/UnderlineThickness 50 def
end readonly def
% End of FontInfo Definition
% Rest of the font dictionnary :
/FontName /FONTNAME def
/PaintType 0 def %
/FontType 1 def
/FontMatrix [0.001 0 0 0.001 0 0] readonly def
/FontBBox [BBOX] readonly def
/Encoding 256 array
0 1 255 {1 index exch /.notdef put} for
ENCODINGSreadonly def
currentdict end
currentfile eexec
}
    
    # Compute bounding box.
    set bbox [map convCoord [lindex $list 2]]
    
    # Create the encoding vector
    foreach c [lrange $list 3 end] {
	set code [lindex $c 0]
	append encoding "dup $code /$name$code put\n"
    }

    # The header can be computed
    set Header [string map [list \
	    FONTNAME $name\
	    FONTFULLNAME $name\
	    FAMILY $name\
	    VERSION 1.0\
	    WEIGHT medium\
	    NOTICE "tcl made from a bzr font"\
	    DATE [clock format [clock seconds]]\
	    BBOX $bbox\
	    ENCODINGS $encoding\
	    ] $Header]
    
    set result $Header
    # Now, we encode chars
    append result [buildEExec $name $list]
    append result "\n"
    append result {0000000000000000000000000000000000000000000000000000000000000000
0000000000000000000000000000000000000000000000000000000000000000
0000000000000000000000000000000000000000000000000000000000000000
0000000000000000000000000000000000000000000000000000000000000000
0000000000000000000000000000000000000000000000000000000000000000
0000000000000000000000000000000000000000000000000000000000000000
0000000000000000000000000000000000000000000000000000000000000000
0000000000000000000000000000000000000000000000000000000000000000
cleartomark
}

}

proc buildEExec {name list} {
    variable VAR
    # Hexa output should be at most 64 columns wide.

    set text [buildEExecASCII $name $list]
    # return $text
    set res ""
    # setR MUST BE HERE (because r is changed in buildEExecASCII !!)
    # it would definitly be better to encapsulate things in a cleaner
    # way.

    Type1Encrypt::setR 55665

    set col 0
    # "random" bytes :
    foreach i {0 0 0 0} {
	set x [Type1Encrypt::cryptChar $i]
	if {$VAR(hexa)} {
	    append res [format %02X $x]
	    incr col 2
	} else {
	    append res [format %c $x]
	}
    }
    
    binary scan $text c* l
    foreach i $l {
	# Let's get sure i is > 0
	set i [expr {( $i + 0x100 ) % 0x100}]
	set x [Type1Encrypt::cryptChar $i]
	if {$VAR(hexa)} {
	    if {$col >= 64} {
		append res "\n"
		set col 0
	    }
	    append res [format %02X $x]
	    incr col 2
	} else {
	    append res [format %c $x]
	}
    }
    return $res
}

proc buildEExecASCII {name list} {
    set result ""
    reset
    # compute the number of chars :
    set nbChars [expr [llength $list] - 3]
    
    append result [getEExecHeader $nbChars]
    append result "\n"
    # Encode the chars :
    foreach c [lrange $list 3 end] {
	set drawing [codeChar $c]
	append result "/$name[lindex $c 0] "
	append result [string length $drawing]
	append result " RD $drawing ND\n"
	reset
    }
    append result [endEExec]
    return $result
}

proc encodeContour {l} {
    variable VAR
    
}

proc closePath {} {
    #return closepath
    return [list 9]
}

proc reset {} {
    variable VAR
    set VAR(x) 0
    set VAR(y) 0
}

proc moveTo {x y} {
    variable VAR
    set dx [expr $x - $VAR(x)]
    set dy [expr $y - $VAR(y)]
    set VAR(x) $x
    set VAR(y) $y
    #return [list $dx $dy rmoveto]
    return [concat [codeInt $dx] [codeInt $dy] 21]
}

proc lineTo {x y} {
    variable VAR
    set dx [expr $x - $VAR(x)]
    set dy [expr $y - $VAR(y)]
    set VAR(x) $x
    set VAR(y) $y
    #return [list $dx $dy rlineto]
    return [concat [codeInt $dx] [codeInt $dy] 5]
}

proc curveTo {c1x c1y c2x c2y x y} {
    variable VAR
    set c1rx [expr $c1x - $VAR(x)]
    set c1ry [expr $c1y - $VAR(y)]

    set c2rx [expr $c2x - $c1x]
    set c2ry [expr $c2y - $c1y]

    set dx [expr $x - $c2x]
    set dy [expr $y - $c2y]
    set VAR(x) $x
    set VAR(y) $y

    #return [list $c1rx $c1ry $c2rx $c2ry $dx $dy rrcurveto]
    return [concat [codeInt $c1rx] [codeInt $c1ry] [codeInt $c2rx] [codeInt $c2ry]\
	    [codeInt $dx] [codeInt $dy] 8]
}

proc endChar {} {
    #return endchar
    return {14}
}

proc charWidth {width bearing} {
    #return [list $bearing $width hsbw]
    return [concat [codeInt $bearing] [codeInt $width] 13]
}

proc charDims {wx wy dx dy} {
    #return [list $dx $dy $wx $wy sbw]
    return [list [codeInt $dx] [codeInt $dy] [codeInt $wx] [codeInt $wy] 12 7]
}

proc closePath {} {
    # return closepath
    return 9
}

# return a list which represents the encoding of i
proc codeInt {i} {
    if {$i >= -107 && $i <= 107} {
	return [list [expr $i + 139]]
    } elseif {$i >= 108 && $i <= 1131} {
	set i [expr {$i - 108}]
	set w [expr {$i % 256}]
	set i [expr {($i - $w) / 256}]
	set v [expr {$i + 247}]
	return [list $v $w]
    } elseif {$i >= -1131 && $i <= -108} {
	set i [expr {-($i + 108)}]
	set w [expr {($i % 256)}]
	set i [expr {($i - $w) / 256}]
	set v [expr {$i + 251}]
	return [list $v $w]
    } else {
	# Ensure big-endian representation :
	set l [binary format i $i]
	# copy the codes in b :
	binary scan $i c* b
	# Now, ensure everyone is positive
	set r {255}
	foreach c $b {
	    lappend r [expr {( $c + 0x100 ) % 0x100}]
	}
	set r [list 255 [expr {($i & 0xFF000000) >> 24}] \
		[expr {($i & 0xFF0000) >> 16}]\
		[expr {($i & 0xFF00) >> 8}]\
		[expr {($i & 0xFF)}]]
	return $r
    }
}


# Takes as input a tcl representation of a bzr char,
# and outputs an equivalent version, with integer data.
# 	scale : equivalent, in bzr space, of 1000 in Type1 space
proc scaleChar {l {scale 17}} {
    set sc [expr {1000 / $scale} ]
    set code [lindex $l 0]
    set width [scaleValue [lindex $l 1] $sc]
    set res [list $code $width]

    for {set i 2} {$i < 6} {incr i} {
	lappend res [scaleValue [lindex $l $i] $sc]
    }
    
    # The char prolog is scaled now.
    # let's scale the paths :
    
    foreach path [lrange $l 6 end] {
	set newPath [lrange $path 0 1]
	for {set i 2} {$i < 4} {incr i} {
	    lappend newPath [scaleValue [lindex $path $i] $sc]
	}
	# for each subpath :
	foreach c [lrange $path 4 end] {
	    set nc [list [lindex $c 0]]
	    foreach x [lrange $c 1 end] {
		lappend nc [scaleValue $x $sc]
	    }
	    lappend newPath $nc
	}
	lappend res $newPath
    }
    return $res
}

proc getEExecHeader {numberOfChars} {
    set h {dup /Private 8 dict dup begin
/RD {string currentfile exch readstring pop} executeonly def 
/ND {noaccess def} executeonly def 
/NP {noaccess put} executeonly def 
/MinFeature {16 16} ND
/password 5839 def
/BlueValues []ND
/Subrs 0 array ND
2 index /CharStrings }
    append h [expr $numberOfChars + 1]
    append h { dict dup begin}
    append h "\n"
    return $h
}

proc endEExec {} {
    set notdef [codeChar {0 17.0 0 0 17.0 17.0 {CMP P 0 0 {l 17 0} {l 0 17} {l 0 0}}}]
    set end {/.notdef }
    append end [string length $notdef]
    append end " RD $notdef ND "
    append end { end end 
readonly put 
noaccess put
dup /FontName get exch definefont pop
mark currentfile closefile
}
}


# Produce a postscript code for a given char
proc codeChar {char} {
    # First, convert the coordinates
    set char [scaleChar $char]
    # Second, produce the list of codes for the char
    set l {}
    #	size and first point :
    # As we append more than one value, we use "eval" :
    eval lappend l [charWidth [lindex $char 1] 0]
    # Now, we start with paths :
    foreach path [lrange $char 6 end] {
	# first point :
	eval lappend l [moveTo [lindex $path 2] [lindex $path 3]]
	# segments :
	foreach segment [lrange $path 4 end] {
	    switch [lindex $segment 0] {
		s {eval lappend l [curveTo [lindex $segment 1] [lindex $segment 2]\
			[lindex $segment 3] [lindex $segment 4]\
			[lindex $segment 5] [lindex $segment 6]]}
		l {eval lappend l [lineTo [lindex $segment 1] [lindex $segment 2]]}
	    }
	}
	eval lappend l [closePath]
    }
    
    eval lappend l [endChar]
    
    # Now, l contains the list of codes for this char.
    # encode it : 

    Type1Encrypt::setR 4330
    
    set encoded {}
    # Four leading 0
    lappend encoded [Type1Encrypt::cryptChar 0]
    lappend encoded [Type1Encrypt::cryptChar 0]
    lappend encoded [Type1Encrypt::cryptChar 0]
    lappend encoded [Type1Encrypt::cryptChar 0]
    # Now, the rest of the text
    foreach i $l {
	lappend encoded [Type1Encrypt::cryptChar $i]
    }
    # returns it as a binary string.

    return [binary format c* $encoded]
}
}

proc scaleValue {v sc} {
    return [expr {round($v*$sc)}]
}


#unsigned short int r;
#unsigned short int c1 = 52845;
# unsigned short int c2 = 22719;
# unsigned char Encrypt(plain) 
# unsigned char plain; 
# {unsigned char cipher; 
# cipher = (plain ^ (r>>8)); 
# r = (cipher + r) * c1 + c2; 
# return cipher; }

namespace eval Type1Encrypt {
    variable c1 52845
    variable c2 22719
    variable r 0
    
    proc cryptChar {c} {
	variable c1
	variable c2
	variable r
	
	set cipher [expr {$c ^ ($r >> 8)}]
	set r [expr {(($cipher + $r) * $c1 + $c2) & 0xFFFF}]
	return $cipher
    }
    
    proc setR {newR} {
	variable r
	set r $newR
    }
    
    # Text is a LIST of chars 
    proc cryptText {l} {
	set res {}
	foreach x $l {
	    lappend res [cryptChar $x]
	}
	return $res
    }
}



#set bzrname [lindex $argv 0]
#set l [sbzr_loadfont $bzrname]
#puts [BzrToType1::bzrToType1 $l HieroFonteA]

#Type1Encrypt::setR 4330

# This test runs 0K.
#set text "00000000BDF9B40D8BEF038BEF01F8ECEF018B16F95006EF07FCEC06F88807F8EC06EF07FD5006090E"
# set text {0 0 0 0 189 249 180 13 139 239 3 139 239 1 248 236 239 1 139 22 249 80 6 239 7 252 236 6 248 136 7 248 236 6 239 7 253 80 6 9 14}
## puts [llength $text]
# foreach  i [Type1Encrypt::cryptText $text] {
#     puts -nonewline [format "%02X " $i]
# }
# puts ""
