
class LineSegment {
    proc LineSegment {this owner p1 p2} Segment {$owner} {
	ControlPoint::control $p1 $this
	ControlPoint::control $p2 $this
	set ($this,p1) $p1
	set ($this,p2) $p2
	GraphElt::draw $this

	set res [GraphElt::getDrawing $this]
	CharEdit::lower $GraphElt::($this,window) $res
	Segment::complete_Segment $this
    }
    
    proc ~LineSegment {this} {
	ControlPoint::detachAndDeleteIfOrphan $LineSegment::($this,p1) $this
	ControlPoint::detachAndDeleteIfOrphan $LineSegment::($this,p2) $this
    }

    proc createDrawing {this} {
	set res [eval $GraphElt::($this,canvas) create line [expandPoints $this] $Segment::($this,smooth)\
		     -fill [Segment::getColor $this]]
	CharEdit::lower $GraphElt::($this,window) $res
	return $res
    }
    
    proc firstPoint {this} {return $LineSegment::($this,p1)}
    proc lastPoint {this} {return $LineSegment::($this,p2)}

    proc expandPoints {this} {
	set p1 $LineSegment::($this,p1)
	set p2 $LineSegment::($this,p2)
	return [concat [Point::coords $p1] [Point::coords $p2]]
    }

    proc getControlPoints {this} {
	return [list $LineSegment::($this,p1) $LineSegment::($this,p2)]
    }

    proc split {this x y} {
	set p1 $LineSegment::($this,p1)
	set p2 $LineSegment::($this,p2)
	# o = The contour !
	set o $Segment::($this,owner)
	set tmp [new Point $x $y]
	set p3 [new ContourControlPoint $tmp $o]
	delete $tmp
	ControlPoint::detach $p2 $this
	set ($this,p2) $p3
	ControlPoint::control $p3 $this
	GraphElt::update $this
	set newseg [new LineSegment $Segment::($this,owner) $p3 $p2]
	Contour::replaceSegment $Segment::($this,owner) $this [list $this $newseg]
    }

    proc double {this} {
	set p1 $LineSegment::($this,p1)
	set p2 $LineSegment::($this,p2)
	set p3 [ContourControlPoint::middle $p1 $p2]
	ControlPoint::detach $p2 $this
	set ($this,p2) $p3
	ControlPoint::control $p3 $this
	GraphElt::update $this
	set newseg [new LineSegment $Segment::($this,owner) $p3 $p2]
	Contour::replaceSegment $Segment::($this,owner) $this [list $this $newseg]
    }

    proc change {this} {		# returns a spline which corresponds to the current element.
	set p1 $LineSegment::($this,p1)
	set p2 $LineSegment::($this,p2)
	set c [Point::middle $p1 $p2]
	set pc1 [Point::middle $p1 $c]
	set pc2 [Point::middle $p2 $c]
	set c1 [new ContourControlPoint $pc1 $ContourControlPoint::($p1,owner)]
	set c2 [new ContourControlPoint $pc2 $ContourControlPoint::($p1,owner)]
	set res [new Spline $Segment::($this,owner) $p1 $c1 $c2 $p2]
	Contour::replaceSegment $Segment::($this,owner) $this $res
	delete $pc1
	delete $pc2
	delete $c
	delete $this
	return $res
    }
    
    virtual proc asText {this} {
	return [concat l \
		    [Point::asText $LineSegment::($this,p2)]]
    }
}
