###############################################################################
#			      les menus hiroglyphiques

################################################################################
# Les menus et diverses autres petites choses.
# should be attached to some window for better flexibility

#menu .menubar -type menubar BUG in TK ?
package require help
package require BWidget

namespace eval mainMenu {
    variable Retrograde 0
    variable textInColumns 0
}

menu .menubar 
. configure -menu .menubar

array set MENUNAME [list \
			files [legendes::trans File]\
			edit [legendes::trans Edit]\
			utils [legendes::trans Utils]\
			signmod [legendes::trans "Sign Modifiers"]\
			signlist [legendes::trans Signs]\
			texte [legendes::trans Text]\
			hachure [legendes::trans Shading]\
			options [legendes::trans Options]\
			help [legendes::trans Help]
			]

foreach {m tear} {files 1 edit 0 texte 0 hachure 0 signmod 0 signlist 1 utils 1 options 0 help 0} {
    set mm [menu .menubar.$m -tearoff $tear]
    .menubar add cascade -label $MENUNAME($m) -menu $mm 
    
    DynamicHelp::register .menubar.$m menu varinfo
}


# LISTE DES FONTES

set listefontes {A B C D E F G H I K L M N O P Q R S T U V W X Y Z Aa}

foreach i $listefontes j $namefontes {
    if { $i == "O" } {
	set cbreak 1
    } else {
	set cbreak 0
    }

    .menubar.signlist  add command -label "$i. $j" \
	-columnbreak $cbreak\
	-command [list fairemenultr $i 0]
}

# UTILS

.menubar.utils add command -label [legendes::trans "Glossary"] \
    -command ouvrir_glossaire

.menubar.utils add command -label [legendes::trans "Ligature editor"] \
    -command Tksesh::ligatureEdit

.menubar.utils add command -label [legendes::trans "Dictionary"] \
	-command openDictionary

.menubar.utils add command -label [legendes::trans "Find hilighted word in dictionnary"] \
	-command [list findWordInDictionary .w]\
	-accelerator "ESC-d"	

.menubar.utils add command -label [legendes::trans "Edit a note"] \
	-command openNote

.menubar.utils add command -label [legendes::trans "Find a word"]\
	-command ouvrir_recherche
#.menubar.utils add command -label [legendes::trans "Translation editor"] \
	-command ouvrir_traduction
.menubar.utils add command -label [legendes::trans "Edit coordinates system"] \
    -command {seshw::edit_coords_system .w}



# EDITION

.menubar.edit add command -label [legendes::trans "Cut"] \
    -command {seshw::couper .w.s}\
    -accelerator "CTRL-x"


.menubar.edit add command -label [legendes::trans "Copy"] \
    -command {seshw::copier .w.s}\
    -accelerator "CTRL-c"

.menubar.edit add command -label [legendes::trans "Paste"] \
    -command {seshw::paste_selection .w.s}\
    -accelerator "CTRL-v"


.menubar.edit add command -label [legendes::trans "Clear"] \
    -command {
	.w.s delete insert endsel
    }

.menubar.edit add separator

.menubar.edit add check -label [legendes::trans "retrograde writing"] \
	-variable mainMenu::Retrograde\
	-command [list seshw::toggleRetrograde .w]

.menubar.edit add check -label [legendes::trans "small signs centered"] \
	-variable mainMenu::Center\
	-command [list seshw::toggleSignCentering .w]


.menubar.edit add separator

.menubar.edit add command -label [legendes::trans "Copy reference"] \
    -command {SESH_insert_ref}

.menubar.edit add separator

.menubar.edit add command -label [legendes::trans "Edit preferences"] \
    -command {seshuser::dialogue}

# TEXTE

.menubar.texte add command -label [legendes::trans "Group horizontally"] \
	-command {seshw::grh .w.s}\
    -accelerator "ESC-h"

.menubar.texte add command -label [legendes::trans "Group vertically"] \
	-command {seshw::grv .w.s}\
    -accelerator "ESC-v"

.menubar.texte add command -label [legendes::trans "Ligature"] \
	-command {seshw::grlig .w.s}\
    -accelerator "ESC-l"

.menubar.texte add command -label [legendes::trans "Explode group"] \
    -command {seshw::explode_cadrat .w.s}\
    -accelerator "ESC-e"

menu .menubar.texte.cartouches 
.menubar.texte add cascade -label [legendes::trans "Cartouches"] \
    -menu .menubar.texte.cartouches

.menubar.texte.cartouches add command -label [legendes::trans "Cartouche"] \
	-command {seshw::cartouche .w.s}\
    -accelerator "ESC-c"

.menubar.texte.cartouches add command -label [legendes::trans "Start of cartouche"] \
	-command {seshw::startCartouche .w.s}

.menubar.texte.cartouches add command -label [legendes::trans "Middle of cartouche"] \
	-command {seshw::middleCartouche .w.s}

.menubar.texte.cartouches add command -label [legendes::trans "End of cartouche"] \
	-command {seshw::endCartouche .w.s}

.menubar.texte.cartouches add command -label [legendes::trans "Serekh"] \
	-command {seshw::serekh .w.s}\

.menubar.texte.cartouches add command -label [legendes::trans "Hout"] \
	-command {seshw::hout .w.s}\


.menubar.texte add command -label [legendes::trans "Editor Restored text"] \
	-command {seshw::crochets .w.s}\
    -accelerator "ESC-("

.menubar.texte add command -label [legendes::trans "Scribe correction"] \
	-command {seshw::crochets .w.s {['-} {-']}}

.menubar.texte add command -label [legendes::trans "Editor added text"] \
    -command {seshw::crochets .w.s {[&-} {-&]}}\
    -accelerator "ESC-<"

.menubar.texte add command -label [legendes::trans "Superfluous text"] \
    -command {seshw::crochets .w.s "\[{-" "-}\]"}\
    -accelerator "ESC-{"

.menubar.texte add command -label [legendes::trans "Shading"] \
    -command {seshw::hachure .w.s}\
    -accelerator "ESC-z"

.menubar.texte add command -label [legendes::trans "Red group"] \
    -command {seshw::enrouge .w.s} \
    -accelerator "ESC-r"

.menubar.texte add command -label [legendes::trans "Black group"] \
        -command {seshw::ennoir .w.s}\
    -accelerator "ESC-b"

.menubar.texte add command -label [legendes::trans "new page"] \
    -command {seshw::addSign .w.s ; seshw::insert_text .w.s {-!!}}\
    -accelerator "Shift-Return"

.menubar.texte add command -label [legendes::trans "Insert coordinates"] \
    -command {seshw::edit_coords .w}


#.menubar.texte add command -label [legendes::trans "Edit comment"] \
#        -command {edit_comment .w.s CM }

.menubar.texte add command -label [legendes::trans "Latin Text"] \
	-command {seshw::winlatininsert .w.s}

.menubar.texte add command -label [legendes::trans "Line  number"] \
	-command {seshw::winnumlineinsert .w.s}

#.menubar.texte add command -label "edit translitteration" 
#        -command {edit_comment .w.s EG}

#.menubar.texte add command -label "edit french translation" 
#        -command {edit_comment .w.s FR}


# Hatchures 

set cbreak 0
foreach h {
    {} 1 12 123 sep 1234 124 13 134 sep 
    14 2 23 234 sep 24 3 34 4  
} {
    if {[string compare $h "sep"] != 0} {

	.menubar.hachure add command -label $h\
	    -image [image create photo -file [file join $env(SESHLIB) icons h${h}.ppm]]\
	    -columnbreak $cbreak\
	    -command [list seshw::hachure_cadrat .w.s $h]
	set cbreak 0
    } else {
	set cbreak 1
    }
}

# FILES

.menubar.files add command -label [legendes::trans "About"] -command about

.menubar.files add command -label [legendes::trans "New Text"] -command {
    new_text .w
}

.menubar.files add command -label [legendes::trans "Load from base"] -command {
    chosetext
}

.menubar.files add command -label [legendes::trans "Save in base"]  -command {
    seshw::savetext .w
}

.menubar.files add command -label [legendes::trans "Insert directory"]  -command {
    insertTextsFromDirectoryIntoDatabase
}

# Test of dynamic help facilities :
DynamicHelp::register .menubar.files menuentry 0 "Detach menu"

DynamicHelp::register .menubar.files menuentry 5 \
    [legendes::trans "insert all .hie files in a directory into the text database."]

help::reg .menubar.files  [file join $env(SESHLIB) ..  doc francais tksesh.help] contents

.menubar.files add separator
.menubar.files add command -label [legendes::trans "Import File"] -command {
    nom_fichier Load charger_fichier
}

.menubar.files add command -label [legendes::trans "Export file"]  -command {
    nom_fichier Save sauver_fichier

}

#.menubar.files add command -label [legendes::trans "Export personal dictionary"]  -command {save_dico}

.menubar.files add command -label [legendes::trans "load old personal dictionary"]  -command {importUserDictionary }

.menubar.files add separator
.menubar.files add command -label  [legendes::trans  "Quit"] -command {tkseshExit}

.menubar.files add check -label [legendes::trans "text in columns"] \
	-variable mainMenu::textInColumns\
	-command [list seshw::toggleColumns .w]

# Sign modifiers
menu .menubar.signmod.rotate -tearoff 0
menu .menubar.signmod.size -tearoff 0

.menubar.signmod add command -label [legendes::trans  "Revert"] -command {seshw::toggle_revert_sign .w.s}
.menubar.signmod add command -label [legendes::trans  "Ignore"] -command {seshw::toggle_sign .w.s ignore}
.menubar.signmod add command -label [legendes::trans  "Sign is wide"] \
							        -command {seshw::toggle_sign .w.s wide}
.menubar.signmod add command -label [legendes::trans  "Toggle word ending"] -command {seshw::toggle_word .w.s}\
    -accelerator "/"
.menubar.signmod add command -label [legendes::trans  "Toggle grammatical ending"] -command {seshw::toggle_gram .w.s}\
    -accelerator "="
.menubar.signmod add cascade -label [legendes::trans  "Rotation"] -menu .menubar.signmod.rotate
.menubar.signmod add cascade -label [legendes::trans  "Size"] -menu .menubar.signmod.size

.menubar.signmod.size add command -label "10%" -command {seshw::set_sign_size .w.s 10}
.menubar.signmod.size add command -label "25%" -command {seshw::set_sign_size .w.s 25}
.menubar.signmod.size add command -label "50%" -command {seshw::set_sign_size .w.s 50}
.menubar.signmod.size add command -label "60%" -command {seshw::set_sign_size .w.s 60}
.menubar.signmod.size add command -label "70%" -command {seshw::set_sign_size .w.s 70}
.menubar.signmod.size add command -label "80%" -command {seshw::set_sign_size .w.s 80}
.menubar.signmod.size add command -label "90%" -command {seshw::set_sign_size .w.s 90}
.menubar.signmod.size add command -label "100%" -command {seshw::set_sign_size .w.s 100}

.menubar.signmod.rotate add command -label "0" -command {seshw::set_sign_rotation .w.s 0}
.menubar.signmod.rotate add command -label "90" -command {seshw::set_sign_rotation .w.s 90}
.menubar.signmod.rotate add command -label "180" -command {seshw::set_sign_rotation .w.s 180}
.menubar.signmod.rotate add command -label "270" -command {seshw::set_sign_rotation .w.s 270}
# options

.menubar.options add command -label [legendes::trans "Show words"] -command {
    .w.s configure -show_words true 
}

.menubar.options add command -label [legendes::trans "Hide words"] -command {
    .w.s configure -show_words false
}

.menubar.options add command -label [legendes::trans "Show text information"] -command {
    catch {seshw::create_info .w}
}

.menubar.options add command -label [legendes::trans "Hide text information"] -command {
    catch {seshw::hide_info .w}
}

# HELP

.menubar.help add command -label [legendes::trans "Tksesh Documentation"] -command tkseshdoc

.menubar.help add command -label [legendes::trans "SQL"] -command sqldoc
.menubar.help add command -label [legendes::trans "sqllite"] -command sqllitedoc
.menubar.help add command -label [legendes::trans "bwidgets"] -command bwidgetsDoc
.menubar.help add command -label [legendes::trans "tablelist"] -command tablelistDoc


if {$tcl_platform(platform) == "unix"} {
    # source [file join  $env(SESHLIB) trans.tcl]
    .menubar.edit add separator
    .menubar.edit add command -label [legendes::trans "transliterate"] \
	-command {

	    set txt [.w.s liste_signes insert endsel]
	    set tr [translit $txt]
	    tk_dialog .dialog [legendes::trans "transliteration"]  "$tr" "" 0 [legendes::trans "Ok"]
	}

    .menubar.edit add command -label [legendes::trans "normalize"] \
	-command {
	    #set txt [selection get -selection $env(DEFAULTSELECTION)]
	    set txt [.w.s liste_signes insert endsel]
	    set tr [hieroglyphs::normalizeText $txt 1]
	    tk_dialog .dialog [legendes::trans "transliteration"]  "$tr" "" 0 [legendes::trans "Ok"]
	}
    
    .menubar.edit add command -label [legendes::trans "transliterate the line"] \
	-command {
	    set txt [.w.s liste_signes -word \
			 -gram insert linestart insert lineend]
	    #set tr [translit $txt]
	    set tr $txt
	    tk_dialog .dialog [legendes::trans "transliteration"]  "$tr" "" 0 [legendes::trans "Ok"]
	}
    
	bind EditorSesh <Key-Escape><Key-m> {
	    set i1 [seshw::get_start_selection .w.s]
	    .w.s towmf $i1 endsel toto.wmf
	}

	bind EditorSesh <Key-Escape><Key-b> {
	    puts hello
	    set i1 [seshw::get_start_selection .w.s]
	    set txt [.w.s toxbm $i1 endsel]
	    set zozo [open "zozo.xbm" w]
	    puts $zozo $txt
	    puts  $zozo "\n"
	    close $zozo
	}

    proc translittere_texte {w} {
	set win [seshw::gethwindow $w]
	regexp {([0-9]+)\..*} [$win index end] tmp lastline
	$win mark set tmp 1.0
	set lnum 1
	
	toplevel .tmpt
	label .tmpt.l -width 10
	pack .tmpt.l
	after 500
	set name [seshw::getname $w]
	set tr "TKSSRC\t$name"
	while  {1} {
	    set txt [$win liste_signes tmp linestart tmp lineend]
	    append tr "\n"
	    set tr1 [translit $txt]
	    set ligne [$win coords get tmp lineend]
	    #puts $tr1
	    append tr "$ligne\t$tr1" 
	    regexp {([0-9]+)\..*} [$win index tmp] dummy lnum
	    if {$lnum == $lastline} break;
	    $win mark set tmp tmp + 1 line
	    .tmpt.l configure -text $lnum
	    update
	}
	destroy .tmpt
	
	# Sauvegarde du texte
	
	#set nom_du_fichier [file rootname [seshtext::getfilename $name]].trl
	#### A MODIFIER. ON SAUVE DANS LA BASE
	set nom_du_fichier ${name}.trl
	set nom_trans [file tail $nom_du_fichier]
	set nom [tk_getSaveFile -initialfile $nom_trans\
		     -defaultextension .trl]
	if { $nom != "" } {
	    set f [open $nom w]
	    puts $f $tr
	    close $f
	}
    }
    
    .menubar.edit add command -label [legendes::trans "Transliterate whole text"] \
	-command {translittere_texte .w}
    
    proc dans_texte {w mot} {
	set trouve 0
	regexp {([0-9]+)\..*} [$w index end] tmp lastline
	$w mark set tmp 1.0
	set lnum 1
	while  {! $trouve} {
	    set ligne [$w liste_signes tmp linestart tmp lineend]
	    set rep [dans_ligne $mot $ligne]
	    if {$rep} {
		set trouve 1
		set pos [$w coords get tmp lineend]
	    }
	    
	    regexp {([0-9]+)\..*} [$w index tmp] dummy lnum
	    if {$lnum == $lastline} break;
	    #puts ">>>>>>>>>>>>>> $lnum <<<<<<<<<<<<<<"
	    $w mark set tmp tmp + 1 line
	    
	}
	if {$trouve} {
	    return $pos
	} else {
	    return 0
	}
    }	
    
    .menubar.edit add command -label [legendes::trans "Find word in text"] \
	-command {
	    set txt [selection get -selection $env(DEFAULTSELECTION)]
	    set rep [dans_texte w.s]
	    if { [string compare $rep "0" ] != 0 } {
		.vb1.seshedit mark set insert "/$rep"
		.vb1.seshedit see insert
	    }
	}
    
} else {
    proc translit {w} {
	return $w
    }
}

proc tkseshdoc {} {
    global env 
    set f [file join $env(SESHLIB) ..  doc francais tksesh.help]
    help::init $f
}

proc sqldoc {} {
    global env 
    set f [file join $env(SESHLIB) ..  doc sqlite lang.html]
    help::init $f
}

proc sqllitedoc {} {
    global env 
    set f [file join $env(SESHLIB) ..  doc sqlite tclsqlite.html]
    help::init $f
}

proc bwidgetsDoc {} {
    global env 
    set f [file join $env(SESHLIB) ..  doc bwidget contents.html]
    help::init $f
}

proc tablelistDoc {} {
    global env 
    set f [file join $env(SESHLIB) ..  doc tablelist index.html]
    help::init $f
}

proc tkseshExit {} {
    delete [TkseshDB::getTkseshDB]
    exit
}

.menubar.edit add command -label [legendes::trans "save as WMF"] \
	-command {
    set i1 [seshw::get_start_selection .w.s]
    .w.s towmf $i1 endsel toto.wmf
}

.menubar.edit add command -label [legendes::trans "Windows Clipboard Copy"] \
	-command {
    set i1 [seshw::get_start_selection .w.s]
    .w.s towinclipboard $i1 endsel
}

.menubar.edit add command -label [legendes::trans "Show undefined signs"] \
	-command {
	    Tksesh::showUndefinedSigns
}

# Dictionnary access from main tksesh window :

bind .w <Key-Escape><Key-d> {
    findWordInDictionary .w ; break
}

bind .w <Control-z> {
    .w.s undocumented4
}


