lappend auto_path [pwd]/..
puts $auto_path
package require stooop
namespace import stooop::*
package require tclSQLDB

# Examples of use of datasources
set db [new SQLDB test.db]

set s [new DataSource $db "select * from students where class = :fixedClass:"]
# (note the use of "fixedClass". It's not a column name, but a "externalField".

# declare the columns type for this source
# note that we have decided not to get the "class" column, as it's the same
# as fixedClass. It would probably be a bad idea to do this for real,
# but we want to make clear the status of all these variables.
DataSource::declareColumns $s {studentID a name t age i}

# declare the fields (if any)
DataSource::declareExternal $s {fixedClass t}

puts "A"
DataSource::setExternalCol $s fixedClass "1st year"
puts "B"

# inits :
DataSource::refresh $s

for {set i 0} {$i < [DataSource::getSize $s]} {incr i} {
    DataSource::setIndex $s $i
    puts "cols [DataSource::getColumnNames $s]"
    foreach col [DataSource::getColumnNames $s] {
	puts [DataSource::getCol $s $col]
    }
}

# allow new student insertion :

DataSource::setCreateRequest $s {
    insert into students (studentID, name, class, age) 
    values (:studentID:, :name:, :fixedClass:, :age:)}

DataSource::createRow $s
DataSource::setCol $s name "Elrond"
DataSource::setCol $s age 3000
DataSource::validate $s

# Note : inserting in more than one table is possible, 
# using ";" and functions like last_insert_rowid or triggers.

delete $db
